C --- STOREC.FOR
C --- CALLED BY INTMAIN
C --- CALLS FILNAM,TMARK
C --- UNITS USED:  LOGU:  (OPEN, WRITE, CLOSE)
C                  DATA1: (OPEN, LEAVE OPEN FOR WRITE, CLOSE) -- .CSV OR CDA DATA
C
C
	SUBROUTINE STOREC
C
C	STORE RESULT OF CALC IN [SAVFIL(1:LSAVFL).CSV
C	OR FILE=[caluic]CALCS\CALCnnnn.CSV WHERE nnn IS
C	CALC NO.  LAST CALC NO IS STORED ON DATA SET [caluic]CALCS\CALC.PRM.
C
C     *NOTE*  THIS VERSION STORES ALL BO SPECIES (NSAVBO IGNORED)
C              SPECIES ORDERING CONST,BO,ACT,SS REQUIRED
C
C	*NOTE ALSO* THIS VERSION ALSO INCLUDES STEPS
C	(TO ADD MORE, CHANGE OUTNAM AND NOUTNM, BELOW)
C
C	IF CONT=T, THEN THE RESULTS OF THE CALC ARE APPENDED ONTO
C	THE END OF SAVFIL
C
	INCLUDE 'MAINSPC.FOR'
C
	PARAMETER (MAXSAV=1000)	! Change formats here and in PRNTC to increase.
	LOGICAL TRY1
	CHARACTER*16 OUTNAM
	CHARACTER*60 OUTFMT
	DATA OUTNAM/'STEPS           '/
	NOUTNM=1
C
	IF (CSVOUT) THEN
		OUTEXT='.CSV'
	ELSE
		OUTEXT='.CDA'
	ENDIF
C
C	IF CONT OPEN EXISTING FILE FOR APPEND AND RETURN
C
	IF (CONT) THEN
		IF (LSAVFL.EQ.0) THEN
			WRITE (ICRT,*) 'Program error in STOREC.FOR'
			WRITE (ICRT,*) 'LSAVFL=0 and CONT=TRUE'
			STOP 'PROGRAM ERROR'
		ENDIF
		OPEN (UNIT=DATA1,FILE=SAVFIL(1:LSAVFL)//OUTEXT,
     &		 ACCESS='APPEND')
		RETURN
	ENDIF
C
C	DETERMINE CHAN NOS TO SAVE
C
	NSAVSS=MIN0(NSS,NSAVSS)
	NSAV=2+(NA2-NA1)+(N0-NB1)+NSAVSS
C
C	OPEN DATA SETS TO WRITE, AND WRITE INITIAL DATA (IF CONT=F)
C	IF OPEN FAILED IT MAY BE THAT SUBFOLDER SPECIFIED THAT DOESN'T EXITS
C	TRY TO CREATE IT.
C
	TRY1=.TRUE.
   22	OPEN (UNIT=DATA1,FILE=SAVFIL(1:LSAVFL)//OUTEXT,STATUS='UNKNOWN'
     &	 ,ERR=23)
C
C	LOG FILE NAME IN LASTCALC.LOG
C
	OPEN (UNIT=TMP1,FILE='LASTCALC.LOG',STATUS='UNKNOWN')
	WRITE (TMP1,'(A)') SAVFIL(1:LSAVFL)//OUTEXT
	CLOSE (UNIT=TMP1)
C
	GOTO 10
   23	IF (TRY1) THEN
		DO 24 I=LSAVFL-1,2,-1
			IF (SAVFIL(I:I).EQ.'\') THEN
				CALL SYSTEM('MD '//SAVFIL(1:I-1))
				TRY1=.FALSE.
				GOTO 22
			ENDIF
   24		CONTINUE
	ENDIF
	WRITE (ICRT,*) 'Unable to open '//SAVFIL(1:LSAVFL)//
     &	 '.CSV for output.'
	STOP
C
   10	CONTINUE
c	IF (INTRAT.OR.SAVER) THEN
c		IF (NSAV+NRXN+NOUTNM.GT.MAXSAV) THEN
c			WRITE (ICRT,*) 'Cannot save more than ',MAXSAV,
c     &			 ' species.  Save RATE and/or INTRATE disabled.'
c			INTRAT=.FALSE.
c			SAVER=.FALSE.
c		ELSEIF (INTRAT.AND.SAVER.AND.
c     &		 NSAV+NRXN+NRXN+NOUTNM.GT.MAXSAV) THEN
c			WRITE (ICRT,*) 'Cannot save more than ',MAXSAV,
c     &			 ' species.  Save RATE disabled.'
c			SAVER=.FALSE.
c		ENDIF
c	ENDIF
	IF (CSVOUT) THEN
		OUTFMT='(I7,3('','',A8,2X),'',''A16,'','',A/'
     &		 //'''Minutes'',1000('','',A10))'
	ELSE
		OUTFMT='(''A8'',I5,3(1X,A8),1X,A16,1X,A/(8(A10,1X)))'
	ENDIF
	CALL TMARK(IOBF16)
	IF (INTRAT) THEN
		IF (SAVER) THEN
			WRITE (DATA1,OUTFMT)
     &			 NSAV+NRXN+NRXN+NOUTNM,FILES,EXTFIL,MOD,IOBF16,
     &			 RUN(1:LNBLNK(RUN(1:64))),
     &			 (NAME(I),I=NA1,NA2),(NAME(I),I=NB1,N0),
     &			 (NAME(I),I=NS1,NS0+NSAVSS),
     &			 ('R#'//RXNLBL(I)//'    ',I=1,NRK),
     &			 ('IR#'//RXNLBL(I)//'   ',I=1,NRK),OUTNAM
		ELSE
			WRITE (DATA1,OUTFMT)
     &			 NSAV+NRXN+NOUTNM,FILES,EXTFIL,MOD,IOBF16,
     &			 RUN(1:LNBLNK(RUN(1:64))),
     &			 (NAME(I),I=NA1,NA2),(NAME(I),I=NB1,N0),
     &			 (NAME(I),I=NS1,NS0+NSAVSS),
     &			 ('IR#'//RXNLBL(I)//'    ',I=1,NRK),OUTNAM
		ENDIF
	ELSE
		IF (SAVER) THEN
			WRITE (DATA1,OUTFMT)
     &			 NSAV+NRXN+NOUTNM,FILES,EXTFIL,MOD,IOBF16,
     &			 RUN(1:LNBLNK(RUN(1:64))),
     &			 (NAME(I),I=NA1,NA2),(NAME(I),I=NB1,N0),
     &			 (NAME(I),I=NS1,NS0+NSAVSS),
     &			 ('R#'//RXNLBL(I)//'    ',I=1,NRK),OUTNAM
		ELSE
			WRITE (DATA1,OUTFMT)
     &			 NSAV+NOUTNM,FILES,EXTFIL,MOD,IOBF16,
     &			 RUN(1:LNBLNK(RUN(1:64))),
     &			 (NAME(I),I=NA1,NA2),(NAME(I),I=NB1,N0),
     &			 (NAME(I),I=NS1,NS0+NSAVSS),OUTNAM
		ENDIF
	ENDIF
C
	RETURN
C
C	ERRORS
C
  900	L=LNBLNK(IOB160)
	WRITE (OUT,*) 'ERROR OPENING '//IOB160(1:L)
	WRITE (6,*) 'Error opening '//IOB160(1:L)
	STOP
  910	WRITE (OUT,*) 'ERROR OPENING '//
     &	 CALUIC(1:LCALUC)//SAVFIL(1:LSAVFL)//OUTEXT
	WRITE (ICRT,*) 'ERROR OPENING '//CALUIC(1:LCALUC)
     &	 //SAVFIL(1:LSAVFL)//OUTEXT
	STOP
	END
C
	SUBROUTINE CLOSEC
C	CLOSES CALCULATION DATA FILE (ENTRY FOR SPECIAL PROCESSING,
C	IF NEEDED).
C	UPDATE CALC.PRM, IF NEEDED
C
	INCLUDE 'MAINSPC.FOR'
C
	WRITE (OUT,2002) CALUIC(1:LCALUC)//SAVFIL(1:LSAVFL)//OUTEXT
 2002	FORMAT (/' FILE = ',A,' STORED.')
	IF (CONT) THEN
		WRITE (ICRT,*) 'File = '//SAVFIL(1:LSAVFL)//OUTEXT
     &		 //' appended.'
	ELSE
		WRITE (ICRT,*) 'File = '//SAVFIL(1:LSAVFL)//OUTEXT
     &		 //' created.'
	ENDIF
	CLOSE (UNIT=DATA1)
	PASSED=.TRUE.
C
	RETURN
	END
