	PROGRAM INT
C
C	RUNS MODEL-SPECIFIC INT PGM.
C	GETS MODEL NAME FROM INT FILE.  GETS MODEL UIC FROM MODELING.PRM
C
C	P1 = .INT FILE NAME
C	P2 = .PRM FILE NAME
C	P3..5 = OPTIONS
C
	LOGICAL ANS,NOPRM,DO3NO
	CHARACTER INLIN*80,MODEL*8,MODUIC*40,FILE*40,PRMFIL*40
	CHARACTER CMDLIN*255
	INCLUDE '..\SUBS\NEWIOBUF.FOR'
C
	CALL GETARG(1,FILE)
	IF (FILE(1:1).EQ.' ') THEN
		WRITE (6,'(A,$)') 'INT file: '
		READ (5,'(A)',END=999) FILE
		IF (FILE(1:1).EQ.' ') GOTO 999
		LF=LNBLNK(FILE)
		PRMFIL=' '
		LP=0
		CMDLIN=FILE
		LCMD=LF
	ELSE
		LF=LNBLNK(FILE)
		CMDLIN=FILE
		LCMD=LF
		LA=2
		LPRMFL=-1
		PRMFIL=' '
C
   10		CALL GETARG(LA,INLIN)
		IF (INLIN(1:1).EQ.' ') THEN
			GOTO 11
		ELSEIF (INLIN(1:2).EQ.'X ') THEN
			LPRMFL=0
		ELSEIF (INLIN(1:4).EQ.'MAX ') THEN
			LA=LA+1
			CALL GETARG (LA,INLIN)
			INLIN='MAX '//INLIN
		ELSEIF (INLIN(1:1).NE.'/'.AND.INLIN(1:5).NE.'SAVE='
     &		 .AND.LPRMFL.EQ.-1) THEN
			PRMFIL=INLIN
			LP=LNBLNK(PRMFIL)
		ENDIF
		CMDLIN=CMDLIN(1:LCMD)//' '//INLIN
		LCMD=LCMD+1+LNBLNK(INLIN)
C
		LA=LA+1
		GOTO 10
  11		IF (LPRMFL.EQ.-1) LPRMFL=0
	ENDIF
C
	CALL INITIN (4)
	IOB160=FILE(1:LF)//'.INT'
	CALL FILEIN
	IF (IORET.NE.0) GOTO 890
C
	MODEL=' '
	LM=0
  110	CALL INBUF ('INT: ',5)
	IF (IORET.EQ.2) GOTO 121
	IF (IOB160(1:6).NE.'MODEL=') GOTO 110
  120	L=LNBLNK(IOB160)
	IF (L.GT.14) L=14
	LM=L-6
	IF (LM.GT.0) MODEL=IOB160(7:L)
  121	CALL INITIN (4)	
C
	LMUIC=0
C
	OPEN (UNIT=1,FILE='MODELING.PRM',STATUS='UNKNOWN')
C
C	READ PARAMETER FILE.  FIRST MODELING.PRM, THEN PRMFILE (IF SPECIFIED)
C	IF ("DO3NO=YES" FOUND, CALCULATE DO3NO)
C
	DO3NO=.FALSE.
	NOPRM=.TRUE.
  200	READ (1,'(A)',END=210) INLIN
	IF (INLIN(1:4).EQ.'MOD=') THEN
		L=LNBLNK(INLIN)
		IF (L.GT.4) THEN
			LMUIC=L-4
			MODUIC=INLIN(5:L)
		ENDIF
	ELSEIF (INLIN(1:9).EQ.'DO3NO=YES') THEN
		DO3NO=.TRUE.
	ELSEIF (LM.LE.0.AND.INLIN(1:7).EQ.'DFLMOD=') THEN
		L=LNBLNK(INLIN)
 		IF (L.GT.15) L=15
 		LM=L-7
 		IF (LM.GT.0) MODEL=INLIN(8:L)
	ENDIF
	GOTO 200
  210	CLOSE (UNIT=1)
C
	IF (NOPRM) THEN
		IF (PRMFIL(1:1).NE.' '.AND.PRMFIL(1:2).NE.'X ') THEN
			NOPRM=.FALSE.
			OPEN (UNIT=1,FILE=PRMFIL(1:LP)//'.PRM',
     &			 STATUS='OLD',ERR=810)
			GOTO 200
		ENDIF
	ENDIF
	IF (LM.LE.0) GOTO 800
C
  299	INLIN=MODUIC
	LM=LMUIC+LM
	INLIN(LMUIC+1:LM)=MODEL
	INLIN(LM+1:LM+4)='.EXE'
	INQUIRE (FILE=INLIN(1:LM+4),EXIST=ANS)
	IF (.NOT.ANS) THEN
		WRITE (6,*) 'File = ',INLIN(1:LM+4),' does not exist.'
		CALL EXIT (2)
	ENDIF
C
	CMDLIN=INLIN(1:LM)//' '//CMDLIN(1:LCMD)
	LCMD=LM+1+LCMD
C
CD	WRITE (6,*) 'CMD='//CMDLIN(1:LCMD)
	CALL SYSTEM (CMDLIN(1:LCMD))
	IF (DO3NO) CALL SYSTEM ('DO3NO 0')
C
C
  999	CALL EXIT (0)
C 
C
  800	WRITE (6,*) 'INT aborted because no model specified.'
	GOTO 899
C
  810	WRITE (6,*) 'File = ',PRMFIL(1:LP),'.PRM does not exist.'
	GOTO 899
C
  890	WRITE (6,*) 'File = ',IOB160(1:LNBLNK(IOB160)),
     &	 ' does not exist.'
C
  899	CALL EXIT (2)
	END
