	PROGRAM RXN2CSV
C
C	OUTPUTS RXN FROM MOD FILE TO CSV
C
C	P1 = PARAMETER FILE TO GET MOD= AND DFLMOD= INFORMATION
C	P2 = OUTPUT CSV FILE NAME. DEFAULT IS "TMP" TO PRODUCE TMP.CSV
C
	LOGICAL ERRIND,FIRST
	CHARACTER PRMFIL*8,DFLMOD*8,OUTFIL*60,MODUIC*60
	CHARACTER INLIN*80,FILNAM*80
C
C	FUNCTION TO SEE HOW MANY RECORDS IT TAKES TO READ I1 DATA
C	VALUES AT I2 VALUES PER RECORD
	NSKPRC(I1,I2)=1+((I1-1)/I2)
C
	CHARACTER*8 FORM,FORMOK/'MV:4/89'/
	PARAMETER (MAXCHR=1024)
	CHARACTER CHARXN(MAXCHR)*1,RXNLBL*4
	LOGICAL NOCONT,NOPRM
C
C	READ COMMAND LINE AND GET RUN ID
C
	CALL GETARG (1,PRMFIL)
	IF ((PRMFIL(1:1).EQ.' ').OR.(PRMFIL(1:1).EQ.'?')) GOTO 800
	LPRMFL=LNBLNK(PRMFIL)
	CALL GETARG (2,OUTFIL)
	IF (OUTFIL(1:1).EQ.' ') THEN
		OUTFIL='TMP.CSV'
		LOUTFL=7
	ELSE
		LOUTFL=LNBLNK(OUTFIL)
		OUTFIL(LOUTFL+1:LOUTFL+4)='.CSV'
		LOUTFL=LOUTFL+4
	ENDIF
C
C	GET PARMS FROM PARAMETER FILE AND MODELING.PRM
C
	OPEN (UNIT=1,FILE='MODELING.PRM',STATUS='UNKNOWN')
C
	MODUIC='.\'
	LMODUC=2
	LDFLMD=0
	FIRST=.TRUE.
C
   10	READ (1,'(A)',END=18) INLIN
	IF (INLIN(1:7).EQ.'DFLMOD=') THEN
		DFLMOD=INLIN(8:)
		LDFLMD=LNBLNK(DFLMOD)
	ELSEIF (INLIN(1:4).EQ.'MOD=') THEN
		MODUIC=INLIN(5:)
		LMODUC=LNBLNK(MODUIC)
	ENDIF
	GOTO 10
  18	CLOSE (UNIT=1)
	IF (FIRST) THEN
		FIRST=.FALSE.
		OPEN (UNIT=1,FILE=PRMFIL(1:LPRMFL)//'.PRM',STATUS='OLD',
     &		 ERR=181)
			NOPRM=.FALSE.
		GOTO 10
  181			NOPRM=.TRUE.
		IF (LDFLMOD.EQ.0) THEN
			DFLMOD=PRMFIL
			LDFLMOD=LPRMFL
			MODUIC=".\"
			LMODUC=2
		ENDIF
		GOTO 10
	ENDIF
C
	IF (NOPRM) THEN
		FILNAM=PRMFIL(1:LPRMFL)//'.MOD'
		LFIL=LPRMFL+4
	ELSE
		FILNAM=MODUIC(1:LMODUC)//DFLMOD(1:LDFLMD)//'.MOD'
		LFIL=LMODUC+LDFLMD+4
	ENDIF
C
C	OPEN .MOD FILE
C
	OPEN (UNIT=1,FILE=FILNAM(1:LFIL),STATUS='OLD',ERR=830)
C
C	OPEN MOD FILE AND SKIP RECORDS NOT USED
C
	READ (1,1) FORM
	IF (FORM.NE.FORMOK) THEN
		WRITE (6,*) 'File = ',FILNAM(1:LFIL),
     &	 	 ' has unrecognized format = "',FORM,'"'
		GOTO 890
	ENDIF
	READ(1,'(A20/12I6/20X,3I6)') INLIN,NS,I,
     &	 NSC,I,I,NRXN,NCOEFV,NCOC1,NCOC2,NPHOTK,LOCKBF,I,
     &	 I,NVTEMP,NVTCO
C
	NSKP=1
	IF (NSC.GT.0) NSKP=NSKP+NSKPRC(NSC,2)
	NSKP=NSKP+NSKPRC(NS-NSC,5)
	IF (NCOEFV.GT.0) NSKP=NSKP+NSKPRC(NCOEFV,3)
	IF (NCOC2.GE.NCOC1) NSKP=NSKP+NSKPRC(NCOC2-NCOC1+1,6)
	IF (NVTCO.GT.0) THEN
		NSKP=NSKP+NSKPRC(NVTEMP,6)+NSKPRC(NVTCO,16)
		DO 14 I=1,NVTCO
  14		NSKP=NSKP+NSKPRC(NVTEMP,6)
	ENDIF
	READ (1,1) (INLIN(1:1),I=1,NSKP)
    1	FORMAT (A)
	IF (NPHOTK.GT.0) THEN
		DO 42 I=1,NPHOTK
		READ (1,'(A/I5)') INLIN(1:1),NPWL
		NSKP=NSKPRC(NPWL,3)
		READ (1,1) (INLIN(1:1),J=1,NSKP)
   42		CONTINUE
	ENDIF
	NSKP=NSKPRC(LOCKBF,6)+(2*NSKPRC(NRXN,16))
	READ (1,1) (INLIN(1:1),I=1,NSKP)
C
C	OPEN OUTPUT FILE AND WRITE INITIAL RECORDS
C
	OPEN (UNIT=2,FILE=OUTFIL(1:LOUTFL),STATUS='UNKNOWN')
C
	WRITE (2,51) PRMFIL(1:LPRMFL),FILNAM(1:LFIL),NRXN
   51	FORMAT ('PRMfile ,',A/'Model  ,',A/'Reactions,',I5/
     &   'RxnLbl,Reaction')
C
C	OUTPUT REACTIONS
C
	DO 50 I=1,NRXN
C
C	READ RXN STRING
C
	READ (1,'(A4,14X,I5,2X,L1/1024A1)') RXNLBL,L,NOCONT,
     &	 (CHARXN(IX),IX=1,L)
   53	IF (.NOT.NOCONT) THEN
		READ (1,'(2X,I5,2X,L1/A)') L1,NOCONT,INLIN
		IF (L.LT.MAXCHR) THEN
			IF (CHARXN(L).EQ.'&') THEN
				L=L-1
				DO 5301 IX=1,L1
 5301				CHARXN(MIN(MAXCHR,L+IX))=INLIN(IX:IX)
				L=L+L1
			ELSEIF (L.EQ.MAXCHR) THEN
				L=L+1	! ADDED STRING IGNORED
                        ELSE
				CHARXN(L+1)=' '
				L=L+1
				DO 5302 IX=1,L1
 5302				CHARXN(MIN(MAXCHR,L+IX))=INLIN(IX:IX)
				L=L+L1
                        ENDIF
			IF (L.GT.MAXCHR) THEN
				L=MAXCHR
				CHARXN(MAXCHR)='&'
			ENDIF
		ENDIF
		GOTO 53
	ENDIF
	WRITE (2,521) RXNLBL(1:LNBLNK(RXNLBL)),(CHARXN(IX),IX=1,L)
  521	FORMAT (A,',',1024A1)
   50	CONTINUE
C
C	DONE OK
C
	CLOSE (UNIT=1)
	CLOSE (UNIT=2)
	WRITE (6,*) 'File = '//OUTFIL(1:LOUTFL)//' created.'
C
	CALL EXIT (0)
C
C	ERRORS
C
  800	WRITE (6,*) 'Outputs reactions in default model in CSV format'
	WRITE (6,*) 'Default output is TMP.CSV'
	WRITE (6,*)
	WRITE (6,*) 'Use: RXN2CSV PRMfile [CSVfile]'
	GOTO 890
C
  810	WRITE (6,*) 'File = ',PRMFIL(1:LPRMFL),'.PRM does not exist.'
	GOTO 890
C
  830	WRITE (6,*) 'File = ',FILNAM(1:LFIL),' does not exist.'
C
  890	CALL EXIT (2)
	END
