	SUBROUTINE BLDUP
C
C	CREATE CODE TO CALCULATE DERIVITIVES OF BUILDUP-ONLY SPECIES.
C	** THIS VERSION DOES NOT COMPUTE LOSS DUE TO DILUTION **
C	** MODIFED TO ALLOW FOR "REACTING" BUILDUP SPECIES **
C
C  --	CONDITIONAL COMPILATION:
C
	INCLUDE 'PSPECS.FOR'
C-
	LOGICAL FIRSTR
C
	INTEGER CBASE,KBASE,RBASE,COBASE,DYBASE,YBASE,SBASE,LBASE
	PARAMETER (CBASE=0,KBASE=1,RBASE=2,COBASE=3,DYBASE=4,YBASE=5,
     &	 SBASE=6,LBASE=7)
C
C
C	PUT SUM OF DILUTION (SIMPLE) + DIL DUE TO DV/DT IN FPR2
C	** DISABLED **
C
C*	CALL LOADN (2,INDDIL,COBASE)
C*	IF (AIRSHD) CALL SUBT (2,INDER,COBASE)
C
C
C	CALC DERIVITIVES.  LOOP OVER BO SPECIES
C
	DO 5000 IR= NB1,NB2
	WRITE (CODEU,1) 'C '//NAME(IR)
    1	FORMAT (A)
C
C	LOAD CONTRIBUTION DUE TO DILUTION
C	** DISABLED UNLESS FORM2=FALSE AND FORM3 NOT ZERO **
C
	FIRSTR=.TRUE.
C*
C	LOOP OVER RXNS.  ADD TO R0 IF IT IS FORMED, SUBTRACT IF IT REACTS 
C	UNLESS FORMAT=3.
C
	DO 5010 IRXN=1,NRXN
	IF (FORM3.EQ.0) THEN
		NR=NRTOSR(IRXN)
		IF (NR.GT.0) THEN
			DO 2310 IX=1,NR
			IF (IRTOSR(IX,IRXN).EQ.IR) THEN  ! FORMS I, SUBTRACT
				IF (FIRSTR) THEN
					CALL LOADN (0,IRXN,RBASE)
					FIRSTR=.FALSE.
				ELSE
					CALL SUBT (0,IRXN,RBASE)
				ENDIF
			ENDIF
 2310			CONTINUE
		ENDIF
	ENDIF
	IP1=NPRODS(IRXN)
	IP2=NPRODS(IRXN+1)-1
	IF (IP2.LT.IP1) GOTO 5010
	DO 5015 I=IP1,IP2
	IF (IPRODS(I).EQ.IR) THEN
C	                         	! THIS REACTION FORMS IR
		J=I-1
		IF (I.GT.IP1.AND.IPRODS(J).LT.0) THEN
C		                                     	! MULT RATE BY COEFS
			IF (FIRSTR) THEN
				K=0
			ELSE
				K=1
			ENDIF
			CALL LOAD (K,IRXN,RBASE)
 5014			CALL MULT (K,-IPRODS(J),COBASE)
			J=J-1
			IF (J.GE.IP1.AND.IPRODS(J).LT.0) GOTO 5014
			IF (FIRSTR) THEN
				FIRSTR=.FALSE.
			ELSE
				CALL ADDR (0,1)
			ENDIF
		ELSE
C		    					! NO RATE INVOLVED.
			IF (FIRSTR) THEN
				CALL LOAD (0,IRXN,RBASE)
				FIRSTR=.FALSE.
			ELSE
				CALL ADD (0,IRXN,RBASE)
			ENDIF
		ENDIF
	ENDIF
 5015	CONTINUE
C    	        	! NOTE THAT IF IR IS PRODUCT TWICE, RATE ADDED TWICE
 5010	CONTINUE
C    	        	! END LOOP OVER REACTIONS
C
	IF (FIRSTR) THEN
		CALL ZER (0,IR-NB0,DYBASE)
	ELSE
		CALL STORE (0,IR-NB0,DYBASE)
	ENDIF
C
	IF (FORM3.EQ.0) GOTO 5000
C
C	IF FORMAT=3, COMPUTE P.U. LOSS RATES
C
	KK=0	! FIRST TO REG 0, SUBTOTS TO REG 1
	DO 4110 IRXN = 1,NRXN
	FIRSTR=.TRUE.
	NR = NRTOSR (IRXN)
        IF (NR.LT.0) GOTO 4110
C
C	SEE IF THIS SPECIES CONSUMED IN THIS REACTION
C
	NN=0
	DO 4112 IX=1,NR
	IF (IRTOSR(IX,IRXN).EQ.IR) NN=NN+1
 4112	CONTINUE
	IF (NN.EQ.0) GOTO 4110
C
C	SPECIES IN THIS REACTION.  LOAD RATE CONSTANT
C
	LKB=LKBUF(IRXN)
	IF (RXTYP(IRXN).EQ.0) THEN
		IF (RXTYP(LKB).EQ.7) THEN
			CALL LOAD (KK,IPHOTR(LKBUF(LKB)),COBASE)
		ELSEIF (RXTYP(LKB).EQ.8) THEN
			CALL LOAD (KK,LKBUF(LKB),COBASE)
		ELSE
			CALL LOAD (KK,LKB,KBASE)
		ENDIF
	ELSEIF (RXTYP(IRXN).EQ.1) THEN
C		IF (LKB.GT.IRXN.OR.DFRATE(LKB).NE.1) ! already checked
		CALL LOAD (KK,LKB,RBASE)
	ELSEIF (RXTYP(IRXN).EQ.7) THEN
		CALL LOAD (KK,IPHOTR(LKB),COBASE)
	ELSEIF (RXTYP(IRXN).EQ.8) THEN
		CALL LOAD (KK,LKB,COBASE)
	ELSE
		CALL LOAD (KK,IRXN,KBASE)
	ENDIF
C
C	MULT BY ALL REACTANT'S EXCEPT FOR FIRST INSTANCE OF IR
C
	DO 4104 IX=1,NR
	J=IRTOSR(IX,IRXN)
	IF (IR.EQ.J.AND.FIRSTR) THEN
		FIRSTR=.FALSE.
		GOTO 4104
	ELSE
		IF (J.GE.NSC1.AND.J.LE.NSC2) THEN
			CALL MULT (KK,J,CBASE)    	! MULT BY CONST CONC
		ELSEIF (J.GE.NA1.AND.J.LE.NA2) THEN
			CALL MULT (KK,J-N0,YBASE)   	! OR MULT BY ACTIVE
		ELSEIF (J.GE.NS1.AND.J.LE.NS2) THEN
			CALL MULT (KK,J-NA2,SBASE)	! ST. STATE
		ELSEIF (J.GE.0) THEN
			WRITE (OUT,*) 'PGM ER AT RATEDEF.  IRXN,J='
     &			 ,IRXN,J
			WRITE (ICRT,*) 'PGM ERR.  CONTINUING.'
		ELSEIF (-J.LE.MAXMAX) THEN
			CALL MULT (KK,-J,COBASE)	! OR MULT BY COEF
		ELSE
			JRXN=-J-MAXMAX			! OR BY RATE CONSTANT
			IF (RXTYP(JRXN).EQ.7) THEN
				CALL MULT (KK,IPHOTR(LKBUF(JRXN)),COBASE)
			ELSEIF (RXTYP(JRXN).EQ.8) THEN
				CALL MULT (KK,LKBUF(JRXN),COBASE)
			ELSE
				CALL MULT (KK,JRXN,KBASE)
			ENDIF
		ENDIF
	ENDIF
 4104	CONTINUE
	IF (.NOT.FIRSTR) THEN
		IF (KK.EQ.0) THEN
			IF (NN.GT.1) THEN
				CALL LOADR(1,0)
				DO 4107 J=2,NN
 4107				CALL ADDR (0,1)
			ENDIF
			KK=1
		ELSE
			DO 4108 J=1,NN
 4108			CALL ADDR (0,1)
		ENDIF
	ENDIF
 4110	CONTINUE
C
	IF (FORM2) THEN
		IF (FIRSTR) THEN
			CALL ZER (0,IR-NB0,LBASE)
			GOTO 5000
		ENDIF
	ELSEIF (FIRSTR) THEN
		CALL LOAD (0,INDDIL,COBASE)
	ELSE
		CALL ADD (0,INDDIL,COBASE)
	ENDIF
	CALL STORE (0,IR-NB0,LBASE)

 5000	CONTINUE
C    	        	! END LOOP OVER BO SPECIES
	RETURN
	END
C-------------------------------------------------------------------------
C
       SUBROUTINE CONSTR
C
C      CREATE CODE TO BE EXECUTED BEFORE INTEGRATION BEGINS
C
C  --  CONDITIONAL COMPILATION:  NOT USED
C-VSB
C.       INCLUDE 'PSPECS/NOLIST'
C-I
       INCLUDE 'PSPECS.FOR'
C-
       INTEGER CBASE,COBASE
       PARAMETER (CBASE=0,COBASE=3)
C
       LOGICAL LOADED
C
C      MODIFY INITIAL CONCENTRATIONS OF SPECIES IN GROUPS
C
       IF (NGRPS.EQ.0) RETURN
C
       DO 200 I=1,NS
          LOADED=.FALSE.
          DO 300 IG=1,NGRPS
          IF (IGROUP(I,IG).NE.0) THEN
                 IF (.NOT.LOADED) THEN
			 CALL LOAD (0,I,CBASE)
C                                                      ! CONC OF SPECIES I
			 LOADED=.TRUE.
                 ENDIF
                 IF (.NOT.AIRSHD) THEN
			 CALL LOAD (1,ITOT(IG),COBASE)
C						       ! INIT TOTAL CONC OF ALL
C						         SPECIES IN GROUP
 			 CALL MULT (1,IGROUP(I,IG),COBASE)
C						       ! * REL AMT OF I IN GRP
			 CALL ADDR (0,1)
C						       ! ADD TO CONC
                  ELSE
                         CALL LOAD (1,ITOT(IG),COBASE)
C						       ! TOTAL OF ALL SPECIES
C						         IN GROUP INIT PRESENT
C						         OR EMITTED
                         CALL MULT (1,IINI(IG),COBASE)
C                                                      ! * FRACTION OF TOTAL
C                                                        INITIALLY PRESENT
 			 CALL MULT (1,IGROUP(I,IG),COBASE)
C						       ! * REL AMT OF I IN GRP
                         CALL MULT (1,INDEF,COBASE)
C                                                      ! * CONVERSION FACTOR
                         CALL DIV (1,INDHT,COBASE)
C                                                      ! / HEIGHT
			 CALL ADDR (0,1)
C						       ! ADD TO CONC
                  ENDIF
          ENDIF
 300      CONTINUE
          IF (LOADED) CALL STORE (0,I,CBASE)
C                                           	     ! SAVE CONC FOR SPECIES I
 200    CONTINUE
        RETURN
        END
