	PROGRAM DUMPLT
C	DEPRECIATED: USE CSVDAT for new applications.
C	Outputs CSV files using GDT or CDA data.
C	FUNCTIONALITY OF LEGACY PLT PROGRAM FOR CREATING CSV FILES
C	ONLY PURPOSE OF THIS PROGRAM IS SO LEGACY PROCEDURES THAT USE PLT
C	TO COMPILE CALC DATA IN CSV FORMAT WILL STILL WORK
C
C
C	Use: PLT file
C	     file = input from file.PLT, output to file.PLO
C
C	Options supported:
C	OPT options ... options applicable for output from this point on
C		CSV ... output in CSV format.  REQUIRED FOR COMPATIBILITY
C		NOPAD  ... separate output by 1 blank line (default is PAD 100)
C		BASE calcid|modelid
C
	PARAMETER (MAXCHN=1000,MAXNPT=1000,MAXOUT=20)
	LOGICAL ERRIND,PAD,USEINST,USECHN,BYHR
	INTEGER NPAD,CHANNO(MAXOUT),LOUTCH(MAXOUT),LOUTNM(MAXOUT),
     &	 CHNPRI(MAXOUT)
	CHARACTER INLIN*240,INFILE*60,OUTNAM(MAXOUT)*20,FILNAM*80,
     &	 NAMEIN*20,INSTIN*20,OUTCHR(MAXOUT)*24,OUTLBL*60,BASE*10
C
	CHARACTER CALUIC*80,GDTUIC*80
	INTEGER LCALUC,LGDTUC
C
	CHARACTER RUNID*10,MODLID*8,NAMES(MAXCHN)*20
	INTEGER NPTS(MAXCHN)
	REAL TIMES(MAXNPT,MAXOUT),DATA(MAXNPT,MAXOUT),DATAI(MAXCHN)
C
C
	CALL GETARG (1,INFILE)
	IF (INFILE(1:1).EQ.'?'.OR.INFILE(1:1).EQ.' ') GOTO 890
	LINFIL=LNBLNK(INFILE)
C
C	DEFAULTS
C
	PAD=.TRUE.
	NPAD=100
	BASE=' '
	LBASE=0
C
	CALUIC='.\'
	LCALUC=2
	GDTUIC='.\'
	LGDTUC=2
	BYHR=.FALSE.
C
C	GET PARMS FROM MODELING.PRM
C
	OPEN (UNIT=1,FILE='MODELING.PRM',STATUS='UNKNOWN')
   10	READ (1,'(A)',END=11) INLIN
	IF (INLIN(1:4).EQ.'CAL=') THEN
		CALUIC=INLIN(5:)
		LCALUC=LNBLNK(CALUIC)
	ELSEIF (INLIN(1:4).EQ.'GDT=') THEN
		GDTUIC=INLIN(5:)
		LGDTUC=LNBLNK(GDTUIC)
	ENDIF
	GOTO 10
   11	CLOSE (UNIT=1)
C
C	OPEN INPUT AND OUTPUT FILES
C
	OPEN (UNIT=1,FILE=INFILE(1:LINFIL)//'.PLT',STATUS='OLD',
     &	 ACTION='READ',ERR=900)
	OPEN (UNIT=2,FILE=INFILE(1:LINFIL)//'.PLO',STATUS='UNKNOWN')
C
C	OPTION INPUT
C
  100	NOUTCH=0
	READ (1,1,END=800) INLIN
	IF (INLIN(1:1).EQ.' ') GOTO 120
	IF (INLIN(1:1).EQ.'!') THEN
		GOTO 100
	ELSEIF (INLIN(1:6).EQ.'NOPAD ') THEN
		PAD=.FALSE.
	ELSEIF (INLIN(1:5).EQ.'BASE ') THEN
		BASE=INLIN(6:)
		LBASE=LNBLNK(BASE)
	ELSEIF (INLIN(1:5).EQ.'HOUR ') THEN
		BYHR=.TRUE.
	ELSEIF (INLIN(1:4).EQ.'CSV ') THEN
	ELSE
		CLOSE (UNIT=1)
		WRITE (6,*) 'Unsupported option: '//INLIN(1:LNBLNK(INLIN))
		GOTO 890
	ENDIF
	GOTO 100
C
C	CHANNEL INPUT
C	PROCESS NAME INPUTS FOR ALL TYPES OF INPUT
C
  120	READ (1,1,END=800) INLIN
    1	FORMAT (A)
	IF (INLIN(1:1).EQ.' ') THEN
		GOTO 100
	ELSEIF (INLIN(1:1).EQ.'!') THEN
		GOTO 100
	ELSEIF (INLIN(1:1).EQ.'C') THEN
		INMODE=1
	ELSEIF (INLIN(1:1).EQ.'G'.OR.INLIN(1:1).EQ.'D') THEN
		INMODE=2
	ELSE
		WRITE (6,*) 'Unsupported data type: '//NAMEIN(1:1)
		GOTO 800
	ENDIF
	IF (INLIN(2:3).EQ.' "') THEN
		IF (NOUTCH.EQ.0) THEN
			WRITE (6,*) 'Reference to undefined channels'
			WRITE (6,*) 'Input: '//INLIN(1:LNBLNK(INLIN))
			GOTO 800
		ENDIF
	ELSE
C
		INLIN=INLIN(3:)
		CALL PARSE0 (20,INLIN,238)
		NOUTCH=1
  130		CALL PARSE1 (NOUTCH,OUTNAM(NOUTCH),LOUTNM(NOUTCH),
     &		 20,INLIN)
		IF (OUTNAM(NOUTCH)(1:1).EQ.' ') THEN
			IF (NOUTCH.EQ.1) THEN
				WRITE (6,*) 'No channels listed'
				GOTO 800
			ELSE
				NOUTCH=NOUTCH-1
			ENDIF
			GOTO 140
		ENDIF
		NPTS(NOUTCH)=0
		IF (NOUTCH.LT.MAXOUT) THEN
			NOUTCH=NOUTCH+1
			GOTO 130
		ENDIF
	ENDIF
C
C	PROCESS CALC OR GDT INPUT
C
  140	READ (1,1,END=800) RUNID
	IF (RUNID(1:1).EQ.' ') GOTO 120
	IF (RUNID(1:1).EQ.'!') GOTO 140
	LRUNID=LNBLNK(RUNID)
C
	IF (INMODE.EQ.1) THEN
C		READ CALC DATA.  RUNID='0' MEANS USE LAST CALC
C
		IF (RUNID(1:LRUNID).EQ.'0') THEN
			OPEN (UNIT=3,FILE='LASTCALC.LOG',STATUS='OLD',
     &			 ACTION='READ',ERR=982)
			READ (3,1,ERR=982) FILNAM
			LFIL=LNBLNK(FILNAM)
			INQUIRE (FILE=FILNAM(1:LFIL),EXIST=ERRIND)
			IF (.NOT.ERRIND) GOTO 300
		ELSEIF (LBASE.EQ.0) THEN
			WRITE (6,*)
     &			 'BASE input is required for calculations'
			GOTO 980
		ELSE
			FILNAM=CALUIC(1:LCALUC)//BASE(1:LBASE)//
     &			 '\'//RUNID(1:LRUNID)//'.CDA'
			LFIL=LCALUC+LBASE+LRUNID+5
			INQUIRE (FILE=FILNAM(1:LFIL),EXIST=ERRIND)
			IF (.NOT.ERRIND) THEN
				FILNAM=CALUIC(1:LCALUC)//RUNID(1:LRUNID)//
     &				 '\'//BASE(1:LBASE)//'.CDA'
				INQUIRE (FILE=FILNAM(1:LFIL),EXIST=ERRIND)
				IF (.NOT.ERRIND) GOTO 300
			ENDIF
		ENDIF
		OPEN (UNIT=3,FILE=FILNAM(1:LFIL),STATUS='OLD',
     &		 ACTION='READ')
C
		READ (3,'(2X,I5)',ERR=930) NCHN
		IF (NCHN.GT.MAXCHN) THEN
			WRITE (6,*) 'Input file has ',NCHN,
     &			 ' channels.  Max = ',MAXCHN
			GOTO 930
		ENDIF
		READ (3,'(8A11)',ERR=930) (NAMES(I),I=1,NCHN)
C
		DO 210 J=1,NOUTCH
		NAMEIN=OUTNAM(J)
		DO 212 I=1,NCHN
		IF (NAMES(I).EQ.NAMEIN) THEN
			CHANNO(J)=I
			GOTO 210
		ENDIF
  212		CONTINUE
		CHANNO(J)=0
  210		CONTINUE
C
		NPT=0
  220		READ (3,'(F10.2/(1PE10.3,7E11.3))',END=230,
     &		 ERR=930) T,(DATAI(I),I=1,NCHN)
		NPT=NPT+1
C
		DO 222 J=1,NOUTCH
		IF (CHANNO(J).NE.0) THEN
			NPTS(J)=NPT
			TIMES(NPT,J)=T
			DATA(NPT,J)=DATAI(CHANNO(J))
		ENDIF
  222		CONTINUE
C
		IF (NPT.LT.NPAD) GOTO 220
  230		CLOSE (UNIT=3)
		NPTMAX=NPTS(1)
C
C
	ELSEIF (INMODE.EQ.2) THEN
C		READ GDT INPUT
C
		FILNAM=GDTUIC(1:LGDTUC)//RUNID(1:LRUNID)//'.GDT'
		LFIL=LGDTUC+LRUNID+4
		MODLID='GDT'
		LMODID=3
C
		INQUIRE (FILE=FILNAM(1:LFIL),EXIST=ERRIND)
		IF (.NOT.ERRIND) GOTO 300
		OPEN (UNIT=3,FILE=FILNAM(1:LFIL),STATUS='OLD',ACTION='READ')
		READ (3,*) I
		IF (I.NE.3) THEN
			WRITE (6,*) 'Only type=3 GDT files supported.'
			GOTO 930
		ENDIF
		READ (3,*,ERR=930)
C
		DO 242 J=1,NOUTCH
		CHANNO(J)=0
		CHNPRI(J)=0
  242		NPTS(J)=0
C
		IF (NOUTCH.GT.1) THEN
			DO 243 J=1,NOUTCH-1
			NAMEIN=OUTNAM(J)
			LJ=LOUTNM(J)
			DO 243 J1=J+1,NOUTCH
			IF ((CHANNO(J1).EQ.0).AND.(NAMEIN(1:LJ).EQ.
     &			 OUTNAM(J1)(1:LOUTNM(J1)))) CHANNO(J1)=J
  243			CONTINUE
		ENDIF
C
		NPTMAX=0
C
C		NEXT CHANNEL
C
  240		READ (3,1,END=280) INLIN
		IF (INLIN(1:1).EQ.' '.OR.INLIN(1:1).EQ.'!') GOTO 240
		CALL PARSE0 (3,INLIN,80)
		CALL PARSE1 (1,NAMEIN,I1,8,INLIN)
		CALL PARSE1 (2,INSTIN,I2,8,INLIN)
		CALL PARSI2 (3,IPRI,1,ERRIND,INLIN)
C
		USEINST=INSTIN(1:1).NE.' '
		IF (USEINST) THEN
			INSTIN=NAMEIN(1:I1)//';'//INSTIN(1:I2)
			I3=I1+I2+1
		ENDIF
C

		DO 255 J=1,NOUTCH
		IF (CHANNO(J).NE.0) GOTO 255
		IF (NAMEIN(1:I1).EQ.OUTNAM(J)(1:LOUTNM(J))) THEN
		ELSEIF (USEINST.AND.(INSTIN(1:I3).EQ.
     &		 OUTNAM(J)(1:LOUTNM(J)))) THEN
		ELSE
			GOTO 255
		ENDIF
		IF (NPTS(J).EQ.0) THEN
		ELSEIF (IPRI.LT.CHNPRI(J)) THEN
		ELSE
			GOTO 255
		ENDIF
		NPTS(J)=0
		CHNPRI(J)=IPRI
  250		READ (3,1,END=280) INLIN
		IF (INLIN(1:1).EQ.'!') GOTO 250
		IF (INLIN(1:1).EQ.'.') GOTO 240
		CALL PARSE0 (2,INLIN,80)
		CALL PARSER (1,T,ERRIND,INLIN)
C		- JUST IGNORE REST OF CHANNEL IF BAD RECORD (USUALLY BLANK)
		IF (ERRIND) GOTO 240
		CALL PARSER (2,XDAT,ERRIND,INLIN)
		IF (ERRIND) GOTO 932
C		THIS VERSION PUTS LAST POINT BEFORE T=0 WITH NPT=1
		NPT=NPTS(J)
		IF (T.LE.0.0) THEN
			IF (NPT.EQ.0) THEN
				T=0.0
				NPT=1
			ELSEIF (NPT.EQ.1) THEN
				T=0.0
			ELSE
				GOTO 250
			ENDIF
		ELSEIF (NPT.EQ.MAXNPT) THEN
			GOTO 260
		ELSE
			NPT=NPT+1
		ENDIF
C
		TIMES(NPT,J)=T
		DATA(NPT,J)=XDAT
		NPTS(J)=NPT
		GOTO 250
  255		CONTINUE
C
C		SKIP CHANNEL
C
  260		READ (3,1,END=280) INLIN
		IF (INLIN(1:1).NE.'.') GOTO 260
		GOTO 240
C
C		EOF
C
  280		CLOSE (UNIT=3)
C
C		FILL IN DUPLICATE CHANNELS
C
		IF (NOUTCH.GT.1) THEN
			DO 282 J=2,NOUTCH
			IF (CHANNO(J).GT.0.AND.NPTS(J).EQ.0) THEN
				J1=CHANNO(J)
				NPT=NPTS(J1)
				IF (NPT.GT.0) THEN
					NPTS(J)=NPT
					DO 283 I=1,NPT
					TIMES(I,J)=TIMES(I,J1)
  283					DATA(I,J)=DATA(I,J1)
				ENDIF
			ENDIF
  282			CONTINUE
		ENDIF
C
	ENDIF
C
C	OUTPUT DATA.  FIRST COMPRESS CHANNELS WITH MORE POINTS THAN NPAD
C
	NPTMAX=0
	DO 400 J=1,NOUTCH
	NPT=NPTS(J)
	IF (NPT.GT.NPAD) THEN
		ISKP=CEILING(FLOAT(NPTS(J))/NPAD)
		JPT=1
		DO 402 I=1+ISKP,NPT,ISKP
		JPT=JPT+1
		TIMES(JPT,J)=TIMES(I,J)
  402		DATA (JPT,J)=DATA(I,J)
		NPT=JPT
		NPTS(J)=JPT
	ENDIF
	IF (NPT.GT.NPTMAX) NPTMAX=NPT
  400	CONTINUE
C	*** ERROR *** MODLID AND LMODID ARE NOT DEFINED
C	WRITE (2,513) RUNID(1:LRUNID),MODLID(1:LMODID)
	WRITE (2,513) RUNID(1:LRUNID),"CHD"
  513	FORMAT (/A,',',A/)
	WRITE (2,511) (OUTNAM(I)(1:LOUTNM(I))//',',
     &	 I=1,NOUTCH)
  511	FORMAT (A,130(',',A))
	DO 500 IPT=1,NPTMAX
	DO 510 J=1,NOUTCH
	IF (NPTS(J).LT.IPT) THEN
		OUTCHR(J)=","
		LOUTCH(J)=1
	ELSE
		IF (BYHR) THEN
			TX=TIMES(IPT,J)/60.
		ELSE
			TX=TIMES(IPT,J)
		ENDIF
		WRITE(OUTCHR(J),512) TX,DATA(IPT,J)
  512		FORMAT (F8.2,',',1PE11.3)
		LOUTCH(J)=20
	ENDIF
  510	CONTINUE
  500	WRITE (2,511) (OUTCHR(J)(1:LOUTCH(J)),J=1,NOUTCH)
	IF (PAD.AND.(IPT.LT.NPAD)) THEN
		DO 514 I=IPT+1,NPAD+1
  514		WRITE (2,*)
	ENDIF
C
	GOTO 140
C
C	OUTPUT IF DATA FILE NOT FOUND
C
  300	WRITE (2,513) RUNID(1:LRUNID),MODLID(1:LMODID)
	WRITE (2,1) 'No file,'//FILNAM(1:LFIL)
	IF (PAD) THEN
		DO 301 I=1,NPAD
  301		WRITE (2,*)
	ENDIF
	GOTO 100
C
C	DONE
C
  800	CLOSE (UNIT=1)
	CLOSE (UNIT=2)
	WRITE (6,*) 'File = '//INFILE(1:LINFIL)//'.PLO created.'
	CALL EXIT (0)
C
C	ERRORS
C
  890	WRITE (6,*) 'Legacy PLT program with CSV functions only.'
	WRITE (6,*) 'Use: PLt file   (file.PLT -> file.PLO)'
	WRITE (6,*) 'Can only be used to output CDA (C) and '
     &	 //'GDT (G) data in CSV format'
	WRITE (6,*) 'Note: No interactive mode'
	CALL EXIT (1)
C
  900	WRITE (6,*) 'File = '//INFILE(1:LINFIL)//'.IN does not exist'
	GOTO 990
  901	WRITE (6,*) 'File = '//FILNAM(1:LFIL)//'.IN does not exist'
	GOTO 980
  910	WRITE (6,*) 'Bad option input: '//INLIN(1:LNBLNK(INLIN))
	GOTO 980
  920	WRITE (6,*) 'Bad data input: '//INLIN(1:LNBLNK(INLIN))
	GOTO 980
  932	WRITE (6,*) 'Bad line = '//INLIN(1:LNBLNK(INLIN))
  930	WRITE (6,*) 'Error reading file: '//FILNAM(1:LFIL)
	GOTO 970
  982	WRITE (6,*) 'Calc #0 used but LASTCALC.LOG corrupt '//
     &	 'or does not exist'
	GO TO 980
C
  970	CLOSE (UNIT=3)
  980	CLOSE (UNIT=1)
	CLOSE (UNIT=2)
  990	CALL EXIT (1)
	END