C.-        THIS FILE PROCESSED USING PARMS = I,  DEBUG=T
C	PRODUCES .SPL SHOWING FITS FOR OPT.
C --- CALLED BY INTMAIN FOR OPT=T
C --- CALLS PGPLT, PGPT1, PGPT2
C --- UNITS USED:  OUT:  (WRITE)
C                  TMP1, TMP2: (OPEN,READ,CLOSE)
C
C --- CONDITIONAL COMPILATION:  V = VAX,   S = SMALL RSX, B = BIG RSX(PDP)
C                               C = CYBER, U = UCSD/CRAY, I = IBM/AT
C -------------------------------------------------------------------------
C
      SUBROUTINE PLOT
C
	INCLUDE 'MAINSPC.FOR'
	INTEGER IND(MAXCHN),NTS(MAXCHN)
	REAL X(MAXTIM,MAXCHN),Y(MAXTIM,MAXCHN),YC(MAXTIM,MAXCHN)
C
C     READ DATA FOR THIS RUN INTO X,Y,XC ARRAYS
C
	OPEN (UNIT=TMP1,FILE=TMPUIC(1:LNBLNK(TMPUIC))//'OPTDAT1.TMP',
     &	 STATUS='OLD',FORM='UNFORMATTED')
C
C	OPEN PLOT OUTPUT FILE
C
	LFIL=LNBLNK(FILES)
	OPEN (UNIT=TMP2,FILE=FILES(1:LFIL)//'.SPL',STATUS='UNKNOWN')
	CALL TMARK (IOB160)
	WRITE (TMP2,1) '#TITLE OPT '//FILES(1:LFIL)//' ('//
     &	 IOB160(1:LNBLNK(IOB160(1:16)))//')'
	WRITE (TMP2,1) '#XLABEL Time'
	WRITE (TMP2,1) '#YLABEL Conc'
	WRITE (TMP2,1) '#NOXLIM'
    1	FORMAT (A)
C
	OPEN (UNIT=TMP3,FILE=FILES(1:LFIL)//'.CSV',STATUS='UNKNOWN')
C
	DO 1000 IRUN=1,NRUNS
	ND=NDATRN(IRUN)
	NC=NOCHN(IRUN)
	DO 1002 I=1,NC
 1002	NTS(I)=0
C
	DO 1010 I=1,ND
	READ (TMP1) J,IX,XI,YI,YCI,YCI
	IF (J.GT.NC) THEN
		WRITE (ICRT,*) 'REC CHAN=',J,' NO CHAN=',NC
		STOP 'PLOT ERROR:  J > NC'
	ENDIF
	IND(J)=IX
	N=NTS(J)+1
	NTS(J)=N
	X(N,J)=XI
	Y(N,J)=YI
 1010	YC(N,J)=YCI
C
	DO 1020 J=1,NC
	K=IND(J)
	N=NTS(J)
	IF (N.EQ.0) GOTO 1020
	WRITE (TMP2,1)
	WRITE (TMP2,1) '* '//RUNLBL(IRUN)(1:LNBLNK(RUNLBL(IRUN)))
     &	 //' '//NAME(K)
C
	WRITE (TMP2,1021) 'A '//RUNLBL(IRUN)(1:LNBLNK(RUNLBL(IRUN)))
     &	 //' '//NAME(K),(X(I,J),Y(I,J),I=1,N)
	WRITE (TMP2,1)
	WRITE (TMP2,1021) '1 Fits',(X(I,J),YC(I,J),I=1,N)
 1021	FORMAT (A/(1P2E11.3))
C
	WRITE (TMP3,1022) CHISQR,','//IOB160(1:LNBLNK(IOB160(1:16)))
     &	 //',Expt.,'//FILES(1:LFIL),
     &	 RUNLBL(IRUN)(1:LNBLNK(RUNLBL(IRUN)))//
     &	 ',,'//RUNLBL(IRUN)(1:LNBLNK(RUNLBL(IRUN))),NAME(K)//',,
     &	 '//NAME(K),(X(I,J),YC(I,J),X(I,J),Y(I,J),I=1,N)
 1022	FORMAT(1PE10.3,A/A//A/(E10.3,',',E10.3,',',E10.3,',',E10.3))
	K1=100*(N/100)
	IF (N.NE.K1.OR.N.EQ.0) THEN
		K1=K1+100
		DO 1023 I=N+1,K1
 1023		WRITE (TMP3,1)
	ENDIF
C	
 1020	CONTINUE
C
 1000	CONTINUE
C
C
	CLOSE (UNIT=TMP1)
	CLOSE (UNIT=TMP2)
	CLOSE (UNIT=TMP3)
	WRITE (OUT,*) 'Files = ',FILES(1:LFIL),
     &	 '.SPL and ',FILES(1:LFIL),'.CSV created.'
	WRITE (ICRT,*) 'Files = ',FILES(1:LFIL),
     &	 '.SPL and ',FILES(1:LFIL),'.CSV created.'
C
C
	RETURN
	END
