      SUBROUTINE ASMD (R1,R2,B2)
C
C     PRODUCES FORTRAN SUBROUTINE FOR USE BY INT PROGRAM
C	MODIFIED BY S. HEFFRON 9/27/85
C
	INTEGER R1,R2,B2
C
	INCLUDE 'PSPECS.FOR'
C
	CHARACTER DNCODE*3
C
C     EXPECTED ARGS WHEN SUBR GENERATED IS CALLED BY INT PROGRAM:
C     A0   A1   A2   A3   A4   A5   A6   A7   A8
C      C    K    R  COEF  DY    Y   SS    T    D
C
C ----------------------------------------------------------------------
C     OPEN FILE FOR FORTRAN CODE BEING GENERATED
C
	ENTRY ASMINI
C
	CODEU=UNIT3
	IF (FORM3.EQ.2) THEN
		IOB160=' '
		CALL FILNAM (NLEN,IOB160,MODUIC,'CHEMPARM.S ',' ')
		OPEN (UNIT=CODEU,FILE=IOB160,STATUS='UNKNOWN')
		WRITE (CODEU,312) MODFIL,NDY
  312		FORMAT ('C     ACTIVE SPECIES FOR MECH = ',A/
     &		 6X,'PARAMETER (NSM=',I2,')')
		CLOSE (UNIT=CODEU)
		WRITE (ICRT,*) 'File = ',IOB160(1:NLEN),' created'
	ENDIF
	IOB160=' '
	CALL FILNAM (NLEN,IOB160,MODUIC,MODFIL,'.FOR ')
	OPEN (UNIT=CODEU,FILE=IOB160,STATUS='UNKNOWN')
C
	IF (FORM3.EQ.2) THEN
		WRITE (CODEU,311) MODFIL(1:8)
  311		FORMAT ('      SUBROUTINE GETMOD (MODNAM)'
     &		 /'      CHARACTER*8 MODNAM'
     &		 /'      MODNAM=''',A8,''''
     &		 /'      RETURN'
     &		 /'      END')
	ELSE
		WRITE (CODEU,31) MODFIL(1:8),MODFIL
   31		FORMAT (6X,'PROGRAM ',A8
     &		 /6X,'CALL INTMAIN (''',A16,''')'
     &		 /6X,'STOP'/6X,'END')
	ENDIF
C
	NC=0
	NC1=0
	DIFNUM=0
	RETURN
C
C ---------------------------------------------------------------------
C     ENTRY TO WRITE 'END' IN FILE, WRITE BLOCK DATA SUBPROGRAM TO
C     INITIALIZE MODEL NAME IN INT PROGRAM, AND CLOSE FILE.
C
      ENTRY SUBEND
C
C	(THIS VERSION DOESN'T WRITE TO FILE, JUST CLOSES IT)
C
      CLOSE (UNIT=CODEU)
      RETURN
C ---------------------------------------------------------------------
C     ENTRIES FOR SINGLE OR NO-REGISTER INSTRUCTIONS
C
C     SECTN:  PRODUCE RETURN INSTRUCTION
C
	ENTRY SECTN
	WRITE (CODEU,600)
  600	FORMAT (6X,'RETURN'/6X,'END')
C
	NC1=NC1+NC
	NC=0
	RETURN
C
C ------------------------------------------------
C     ENTRIES FOR REGISTER-REGISTER INSTRUCTIONS
C
	ENTRY ZERR (R1)
	WRITE (CODEU,'(6X,''R'',I1,'' = 0.'')') R1
	GOTO 1210
C
      ENTRY NEGR (R1)
      WRITE (CODEU,602) R1,R1
 602  FORMAT (6X,'R',I1,' = -R',I1)
      GOTO 1210
C
      ENTRY LOADR (R1,R2)
      WRITE (CODEU,604) R1,R2
 604  FORMAT (6X,'R',I1,' = R',I1)
      GOTO 1210
C
      ENTRY LOADNR (R1,R2)
      WRITE (CODEU,602) R1,R2
      GOTO 1210
C
      ENTRY ADDR (R1,R2)
      WRITE (CODEU,606) R1,R1,R2
 606  FORMAT (6X,'R',I1,' = R',I1,' + R',I1)
      GOTO 1210
C
      ENTRY SUBTR (R1,R2)
      WRITE (CODEU,608) R1,R1,R2
 608  FORMAT (6X,'R',I1,' = R',I1,' - R',I1)
      GOTO 1210
C
      ENTRY MULTR (R1,R2)
      WRITE (CODEU,610) R1,R1,R2
 610  FORMAT (6X,'R',I1,' = R',I1,' * R',I1)
      GOTO 1210
C
      ENTRY DIVR (R1,R2)
      WRITE (CODEU,612) R1,R1,R2
 612  FORMAT (6X,'R',I1,' = R',I1,'/R',I1)
      GOTO 1210
C
C -------------------------------------------------------------
C     ENTRIES FOR REGISTER-MEMORY INSTRUCTIONS
C
      ENTRY STORE (R1,R2,B2)
      WRITE (CODEU,614) B2,R2,R1
 614  FORMAT (6X,'A',I1,'(',I5,') = R',I1)
      GO TO 1200
C
      ENTRY LOAD (R1,R2,B2)
      WRITE (CODEU,616) R1,B2,R2
 616  FORMAT (6X,'R',I1,' = A',I1,'(',I5,')')
      GO TO 1200
C
      ENTRY LOADN (R1,R2,B2)
      WRITE (CODEU,618) R1,B2,R2
 618  FORMAT (6X,'R',I1,' = -A',I1,'(',I5,')')
      GO TO 1200
C
      ENTRY ADD (R1,R2,B2)
C	IF (R2.LE.0.OR.R2.GT.9999) THEN
C		WRITE (6,*) 'BAD CALL TO ASMD'
C	ENDIF
      WRITE (CODEU,620) R1,R1,B2,R2
 620  FORMAT (6X,'R',I1,' = R',I1,' + A',I1,'(',I5,')')
      GO TO 1200
C
      ENTRY SUBT (R1,R2,B2)
      WRITE (CODEU,622) R1,R1,B2,R2
 622  FORMAT (6X,'R',I1,' = R',I1,' - A',I1,'(',I5,')')
      GO TO 1200
C
      ENTRY MULT  (R1,R2,B2)
      WRITE (CODEU,624) R1,R1,B2,R2
 624  FORMAT (6X,'R',I1,' = R',I1,' * A',I1,'(',I5,')')
      GO TO 1200
C
      ENTRY DIV (R1,R2,B2)
      WRITE (CODEU,626) R1,R1,B2,R2
 626  FORMAT (6X,'R',I1,' = R',I1,'/A',I1,'(',I5,')')
      GOTO 1200
C
	ENTRY ZER (R2,B2)
	WRITE (CODEU,627) B2,R2
 627	FORMAT (6X,'A',I1,'(',I5,') = 0.')
	GOTO 1200	
C
 1200	IF (B2.LT.0.OR.B2.GT.8) GOTO 900
C
 1210	NC=NC+1
C
C	BREAK UP INTO SUBROUTINES IF MORE THAN MAXKOD LINES
C	SINCE START OF THIS SUBROUTINE
C
	IF (NC.GT.MAXKOD) THEN
		NC1=NC
		NC=0
		DIFNUM=DIFNUM+1
		WRITE (DNCODE,'(I3)') 100+DIFNUM
		WRITE (CODEU,1211) DNCODE(2:3),DNCODE(2:3)
 1211		FORMAT (6X,'CALL DIFN',A2,'(R0,R1,R2,A0,A1,A2,A3,',
     &		 'A4,A5,A6,TIME,TEMP)'/6X,'RETURN'/6X,'END'
     &		 /6X,'SUBROUTINE DIFN',A2,'(R0,R1,R2,A0,A1,A2,A3,',
     &		 'A4,A5,A6,TIME,TEMP)'/6X,'REAL A0(*),A1(*),A2(*)',
     &		 ',A3(*),A4(*),A5(*),A6(*)'/6X,'REAL R0,R1,R2')
	ENDIF
C		
C	DUMMY ENTRY FOR FREREG
	ENTRY FREREG (B2)
C
	RETURN
C
C
C	ENTRY TO INCREMENT CODE NO.  DON'T CHECK IF R1=0.
C
	ENTRY CHKKOD (R1)
	NC=NC+1
	IF (R1.EQ.0.AND.NC.GT.MAXKOD) THEN
		NC1=NC
		NC=0
		DIFNUM=DIFNUM+1
		WRITE (DNCODE,'(I3)') 100+DIFNUM
		WRITE (CODEU,1211) DNCODE(2:3)
	ENDIF
	RETURN
C
C ----------------------------------------------------------------------
C     ERROR SECTION.  DELIBERATELY CAUSE ERROR
C     TO GET TRACEBACK
C
  900 WRITE (OUT,901) R1,R2,B2
  901 FORMAT (' ILLEGAL ARGUMENTS ON CALL TO ASMD.  ARGS =',
     & 3I10)
      I=0
      I=1/I
      STOP
      END
C
C ----------------------------------------------------------------------
